<?php
/////////////////////////////////////////////////////////////////
/// getID3() by James Heinrich <info@getid3.org>               //
//  available at http://getid3.sourceforge.net                ///
//            or http://www.getid3.org                        ///
/////////////////////////////////////////////////////////////////
//                                                             //
// getid3.demo.mysql.php - part of getID3()                    //
// Sample script for recursively scanning directories and      //
// storing the results in a database                           //
// See getid3.readme.txt for more details                      //
//                                                             //
/////////////////////////////////////////////////////////////////

if (!@mysql_connect('localhost', 'getid3', 'getid3')) {
	die('Could not connect to MySQL host');
}
if (!@mysql_select_db('getid3')) {
	die('Could not select database');
}

if (!empty($_REQUEST['renamefilefrom']) && !empty($_REQUEST['renamefileto'])) {

	if ($_REQUEST['renamefilefrom'] === $_REQUEST['renamefileto']) {
		$results = '<SPAN STYLE="color: #FF0000;"><B>Source and Destination filenames identical</B><BR>FAILED to rename';
	} elseif (!file_exists($_REQUEST['renamefilefrom'])) {
		$results = '<SPAN STYLE="color: #FF0000;"><B>Source file does not exist</B><BR>FAILED to rename';
	} elseif (file_exists($_REQUEST['renamefileto']) && (strtolower($_REQUEST['renamefilefrom']) !== strtolower($_REQUEST['renamefileto']))) {
		$results = '<SPAN STYLE="color: #FF0000;"><B>Destination file already exists</B><BR>FAILED to rename';
	} elseif (@rename($_REQUEST['renamefilefrom'], $_REQUEST['renamefileto'])) {
		$SQLquery = 'DELETE FROM files WHERE (filename = "'.mysql_escape_string($_REQUEST['renamefilefrom']).'")';
		safe_mysql_query($SQLquery);
		$results = '<SPAN STYLE="color: #008000;">Successfully renamed';
	} else {
		$results = '<BR><SPAN STYLE="color: #FF0000;">FAILED to rename';
	}
	$results .= ' from:<BR><I>'.$_REQUEST['renamefilefrom'].'</I><BR>to:<BR><I>'.$_REQUEST['renamefileto'].'</I></SPAN><HR>';
	echo $results;
	exit;

} elseif (!empty($_REQUEST['m3ufilename'])) {

	header('Content-type: audio/x-mpegurl');
	echo '#EXTM3U'."\n";
	echo $_REQUEST['m3ufilename']."\n";
	exit;

} elseif (!isset($_REQUEST['m3u'])) {

	echo '<HTML><HEAD><STYLE>BODY, TD, TH { font-family: sans-serif; font-size: 10pt; } A { text-decoration: none; } A:hover { text-decoration: underline; } A:visited { font-style: italic; }</STYLE></HEAD><BODY>';

}

require_once('getid3.php');



function safe_mysql_query($SQLquery) {
	$result = @mysql_query($SQLquery);
	if (mysql_error()) {
		die('<FONT COLOR="red">'.mysql_error().'</FONT><HR><TT>'.$SQLquery.'</TT>');
	}
	return $result;
}

function mysql_table_exists($tablename) {
	return (bool) mysql_query('DESCRIBE '.$tablename);
}

function AcceptableExtensions($fileformat, $audio_dataformat='', $video_dataformat='') {
	static $AcceptableExtensionsAudio = array();
	if (empty($AcceptableExtensionsAudio)) {
		$AcceptableExtensionsAudio['mp3']['mp3']  = array('mp3');
		$AcceptableExtensionsAudio['mp2']['mp2']  = array('mp2');
		$AcceptableExtensionsAudio['mp1']['mp1']  = array('mp1');
		$AcceptableExtensionsAudio['asf']['asf']  = array('asf');
		$AcceptableExtensionsAudio['asf']['wma']  = array('wma');
		$AcceptableExtensionsAudio['riff']['mp3'] = array('wav');
		$AcceptableExtensionsAudio['riff']['wav'] = array('wav');
	}
	static $AcceptableExtensionsVideo = array();
	if (empty($AcceptableExtensionsVideo)) {
		$AcceptableExtensionsVideo['mp3']['mp3']  = array('mp3');
		$AcceptableExtensionsVideo['mp2']['mp2']  = array('mp2');
		$AcceptableExtensionsVideo['mp1']['mp1']  = array('mp1');
		$AcceptableExtensionsVideo['asf']['asf']  = array('asf');
		$AcceptableExtensionsVideo['asf']['wmv']  = array('wmv');
		$AcceptableExtensionsVideo['gif']['gif']  = array('gif');
		$AcceptableExtensionsVideo['jpg']['jpg']  = array('jpg');
		$AcceptableExtensionsVideo['png']['png']  = array('png');
		$AcceptableExtensionsVideo['bmp']['bmp']  = array('bmp');
	}
	if (!empty($video_dataformat)) {
		return (isset($AcceptableExtensionsVideo[$fileformat][$video_dataformat]) ? $AcceptableExtensionsVideo[$fileformat][$video_dataformat] : array());
	} else {
		return (isset($AcceptableExtensionsAudio[$fileformat][$audio_dataformat]) ? $AcceptableExtensionsAudio[$fileformat][$audio_dataformat] : array());
	}
}

function ClosestStandardMP3Bitrate($bitrate) {
	static $StandardBitrates = array(320, 256, 224, 192, 160, 128, 112, 96, 80, 64, 56, 48, 40, 32);
	static $BitrateTable = array(0=>'-');
	$roundbitrate = round($bitrate / 1000);
	if (!isset($BitrateTable[$roundbitrate])) {
		if ($roundbitrate > 320) {
			$BitrateTable[$roundbitrate] = (round($bitrate / 10000) * 10000) / 1000;
		} else {
			$LastBitrate = 320;
			foreach ($StandardBitrates as $StandardBitrate) {
				$BitrateTable[$roundbitrate] = $StandardBitrate;
				if ($roundbitrate >= $StandardBitrate - (($LastBitrate - $StandardBitrate) / 2)) {
					break;
				}
				$LastBitrate = $StandardBitrate;
			}
		}
	}
	return $BitrateTable[$roundbitrate];
}


if (!empty($_REQUEST['scan'])) {
	if (mysql_table_exists('files')) {
		$SQLquery  = 'DROP TABLE files';
		safe_mysql_query($SQLquery);
	}
}
if (!mysql_table_exists('files')) {
	$SQLquery  = 'CREATE TABLE files (';
	$SQLquery .= '  ID mediumint(8) unsigned NOT NULL auto_increment,';
	$SQLquery .= '  filename text NOT NULL,';
	$SQLquery .= '  LastModified text NOT NULL,';
	$SQLquery .= '  md5_file varchar(32) NOT NULL default "",';
	$SQLquery .= '  md5_data varchar(32) NOT NULL default "",';
	$SQLquery .= '  md5_data_source varchar(32) NOT NULL default "",';
	$SQLquery .= '  filesize int(10) unsigned NOT NULL default "0",';
	$SQLquery .= '  fileformat varchar(255) NOT NULL default "",';
	$SQLquery .= '  audio_dataformat varchar(255) NOT NULL default "",';
	$SQLquery .= '  video_dataformat varchar(255) NOT NULL default "",';
	$SQLquery .= '  audio_bitrate float NOT NULL default "0",';
	$SQLquery .= '  video_bitrate float NOT NULL default "0",';
	$SQLquery .= '  playtime_seconds varchar(255) NOT NULL default "",';
	$SQLquery .= '  tags varchar(255) NOT NULL default "",';
	$SQLquery .= '  artist varchar(255) NOT NULL default "",';
	$SQLquery .= '  title varchar(255) NOT NULL default "",';
	$SQLquery .= '  album varchar(255) NOT NULL default "",';
	$SQLquery .= '  genre varchar(255) NOT NULL default "",';
	$SQLquery .= '  comment varchar(255) NOT NULL default "",';
	$SQLquery .= '  track tinyint(3) unsigned NOT NULL default "0",';
	$SQLquery .= '  comments_all text NOT NULL,';
	$SQLquery .= '  comments_id3v2 text NOT NULL,';
	$SQLquery .= '  comments_ape text NOT NULL,';
	$SQLquery .= '  comments_lyrics3 text NOT NULL,';
	$SQLquery .= '  comments_id3v1 text NOT NULL,';
	$SQLquery .= '  warning text NOT NULL,';
	$SQLquery .= '  error text NOT NULL,';
	$SQLquery .= '  vbr_method varchar(255) NOT NULL default "",';
	$SQLquery .= '  PRIMARY KEY  (ID)';
	$SQLquery .= ') TYPE=MyISAM;';
	safe_mysql_query($SQLquery);
}

function SynchronizeAllTags($filename, $synchronizefrom='all', $synchronizeto='A12') {

	set_time_limit(30);

	$ThisFileInfo = GetAllFileInfo($filename);
	if (empty($ThisFileInfo['fileformat']) || ($ThisFileInfo['fileformat'] == 'id3')) {
		if (isset($formatExtensions[strtolower(fileextension($filename))])) {
			$ThisFileInfo = GetAllFileInfo($filename, $formatExtensions[strtolower(fileextension($filename))]);
		}
	}
	if ($synchronizefrom == 'all') {
		$SourceArray = $ThisFileInfo['comments'];
	} elseif (!empty($ThisFileInfo[$synchronizefrom]['comments'])) {
		$SourceArray = $ThisFileInfo[$synchronizefrom]['comments'];
	} else {
		die('ERROR: $ThisFileInfo['.$synchronizefrom.'][comments] does not exist');
	}

	$SourceArray['title']   = (isset($SourceArray['title'])   ? $SourceArray['title']   : array());
	$SourceArray['artist']  = (isset($SourceArray['artist'])  ? $SourceArray['artist']  : array());
	$SourceArray['album']   = (isset($SourceArray['album'])   ? $SourceArray['album']   : array());
	$SourceArray['year']    = (isset($SourceArray['year'])    ? $SourceArray['year']    : array());
	$SourceArray['genre']   = (isset($SourceArray['genre'])   ? $SourceArray['genre']   : array());
	$SourceArray['track']   = (isset($SourceArray['track'])   ? $SourceArray['track']   : array());
	$SourceArray['comment'] = (isset($SourceArray['comment']) ? $SourceArray['comment'] : array());

	$Success = array();

	if (($synchronizefrom != 'id3v1') && (strstr($synchronizeto, '1'))) {
		$GenreValue = @$SourceArray['genre'][0];
		if (!is_numeric($GenreValue)) {
			$LookupGenreValue = LookupGenre($GenreValue, true);
			if (is_numeric($LookupGenreValue)) {
				$GenreValue = $LookupGenreValue;
			} else {
				$GenreValue = (isset($ThisFileInfo['id3v1']['genreid']) ? $ThisFileInfo['id3v1']['genreid'] : 255);
			}
		}
		require_once(GETID3_INCLUDEPATH.'getid3.id3v1.php');
		$Success['id3v1'] = WriteID3v1(
			$filename,
			implode(', ', $SourceArray['title']),
			implode(', ', $SourceArray['artist']),
			implode(', ', $SourceArray['album']),
			implode(', ', $SourceArray['year']),
			implode(', ', $SourceArray['comment']),
			$GenreValue,
			(!empty($SourceArray['tracknumber'][0]) ? $SourceArray['tracknumber'][0] : @$SourceArray['track'][0]),
			false);
	}

	if (($synchronizefrom != 'ape') && (strstr($synchronizeto, 'A'))) {
		$newAPEdata = array();
		if (isset($ThisFileInfo['ape']['items']) && is_array($ThisFileInfo['ape']['items'])) {
			foreach ($ThisFileInfo['ape']['items'] as $key => $value) {
				foreach ($value['data'] as $datakey => $datavalue) {
					$newAPEdata[$key][] = $datavalue;
				}
			}
		}
		foreach ($SourceArray as $key => $value) {
			switch (strtolower($key)) {
				case 'track':
					$key = 'tracknumber';
					break;
				case 'year':
					$key = 'date';
					break;
				case 'genreid':
					$key = false;
					break;
				default:
					break;
			}
			unset($newAPEdata[$key]);
			if ($key !== false) {
				$newAPEdata[$key] = $value;
			}
		}
		require_once(GETID3_INCLUDEPATH.'getid3.ape.php');
		$Success['ape'] = WriteAPEtag($filename, $newAPEdata, true, false);
	}

	if (($synchronizefrom != 'id3v2') && (strstr($synchronizeto, '2'))) {

		$ID3v2data = array();
		if (!empty($ThisFileInfo['id3v2'])) {
			if ($ThisFileInfo['id3v2']['majorversion'] == 2) {
				die('Cannot copy data from ID3v2.2');
			}
			$ID3v2data = $ThisFileInfo['id3v2'];

			foreach ($ID3v2data as $key => $value) {
				if (!IsValidID3v2FrameName($key, 3)) {
					unset($ID3v2data[$key]);
				} elseif (isset($value['asciidata']) && ($value['asciidata'] === false)) {
					unset($ID3v2data[$key]);
				} elseif (isset($value[0]['url']) && ($value[0]['url'] === false)) {
					unset($ID3v2data[$key]);
				} elseif (isset($value[0]['asciidata']) && ($value[0]['asciidata'] === false)) {
					unset($ID3v2data[$key]);
				}
			}
		}

		foreach ($SourceArray as $key => $value) {
			switch ($key) {
				case 'title':
					unset($ID3v2data['TIT2']);
					$ID3v2data['TIT2']['encodingid'] = 0;
					$ID3v2data['TIT2']['data']       = implode(', ', $SourceArray[$key]);
					break;

				case 'artist':
					unset($ID3v2data['TPE1']);
					$ID3v2data['TPE1']['encodingid'] = 0;
					$ID3v2data['TPE1']['data']       = implode(', ', $SourceArray[$key]);
					break;

				case 'album':
					unset($ID3v2data['TALB']);
					$ID3v2data['TALB']['encodingid'] = 0;
					$ID3v2data['TALB']['data']       = implode(', ', $SourceArray[$key]);
					break;

				case 'year':
					unset($ID3v2data['TYER']);
					$ID3v2data['TYER']['encodingid'] = 0;
					$ID3v2data['TYER']['data']       = implode(', ', $SourceArray[$key]);
					break;

				case 'comment':
					unset($ID3v2data['COMM']);
					foreach ($SourceArray[$key] as $commentID => $commentData) {
						$ID3v2data['COMM'][$commentID]['encodingid']  = 0;
						$ID3v2data['COMM'][$commentID]['language']    = 'eng';
						$ID3v2data['COMM'][$commentID]['description'] = '';
						$ID3v2data['COMM'][$commentID]['data']        = $commentData;
					}
					break;

				case 'track':
				case 'tracknumber':
					unset($ID3v2data['TRCK']);
					$ID3v2data['TRCK']['encodingid'] = 0;
					$ID3v2data['TRCK']['data']       = implode(', ', $SourceArray[$key]);
					break;

				case 'genre':
					unset($ID3v2data['TCON']);
					$GenreValue = @$SourceArray[$key][0];
					if (is_numeric($GenreValue)) {
						$GenreValue = '('.$GenreValue.')';
					} else {
						$LookupGenreValue = LookupGenre($GenreValue, true);
						if (is_numeric($LookupGenreValue)) {
							$GenreValue = '('.$LookupGenreValue.')';
						}
					}
					$ID3v2data['TCON']['encodingid'] = 0;
					$ID3v2data['TCON']['data']       = $GenreValue;
					break;

				default:
					break;
			}
		}

		foreach ($ID3v2data as $key => $value) {
			if (!IsValidID3v2FrameName($key, 3)) {
				unset($data[$key]);
			} elseif (isset($value['asciidata']) && ($value['asciidata'] === false)) {
				unset($data[$key]);
			} elseif (isset($value[0]['url']) && ($value[0]['url'] === false)) {
				unset($data[$key]);
			} elseif (isset($value[0]['asciidata']) && ($value[0]['asciidata'] === false)) {
				unset($data[$key]);
			}

			if (isset($value['language']) && (LanguageLookup($value['language']) == '')) {
				$data[$key]['language'] = 'XXX';
			} elseif (isset($value[0]['language']) && (LanguageLookup($value[0]['language']) == '')) {
				$data[$key][0]['language'] = 'XXX';
			}

		}

		require_once(GETID3_INCLUDEPATH.'getid3.id3v2.php');
		$Success['id3v2'] = WriteID3v2(
			$filename,
			$ID3v2data,
			3,
			0,
			true,
			4096,
			true);
	}

	$SQLquery = 'DELETE FROM files WHERE (filename = "'.mysql_escape_string($filename).'")';
	safe_mysql_query($SQLquery);

	return $Success;
}

$IgnoreNoTagFormats = array('', 'png', 'jpg', 'gif', 'bmp', 'swf', 'zip', 'mid', 'mod', 'xm', 'it', 's3m');

if (!empty($_REQUEST['scan']) || !empty($_REQUEST['newscan']) || !empty($_REQUEST['rescanerrors'])) {

	$SQLquery  = 'DELETE from `files` WHERE (fileformat = "")';
	safe_mysql_query($SQLquery);

	$FilesInDir = array();

	if (!empty($_REQUEST['rescanerrors'])) {

		echo 'Re-scanning all media files already in database that had errors and/or warnings in last scan<HR>';

		$SQLquery = 'SELECT filename FROM files WHERE (error <> "") OR (warning <> "") ORDER BY filename ASC';
		$result = safe_mysql_query($SQLquery);
		while ($row = mysql_fetch_array($result)) {

			if (!file_exists($row['filename'])) {
				echo '<B>File missing: '.$row['filename'].'</B><BR>';
				$SQLquery = 'DELETE FROM files WHERE (filename = "'.FixDBFields($row['filename']).'")';
				safe_mysql_query($SQLquery);
			} else {
				$FilesInDir[] = $row['filename'];
			}

		}

	} elseif (!empty($_REQUEST['scan']) || !empty($_REQUEST['newscan'])) {

		echo 'Scanning all media files in <B>'.realpath(!empty($_REQUEST['scan']) ? $_REQUEST['scan'] : $_REQUEST['newscan']).'</B> (and subdirectories)<HR>';

		$SQLquery  = 'SELECT COUNT(*) AS num, filename';
		$SQLquery .= ' FROM `files`';
		$SQLquery .= ' GROUP BY filename';
		$SQLquery .= ' ORDER BY num DESC';
		$result = safe_mysql_query($SQLquery);
		$DupesDeleted = 0;
		while ($row = mysql_fetch_array($result)) {
			set_time_limit(30);
			if ($row['num'] <= 1) {
				break;
			}
			$SQLquery = 'DELETE FROM `files` WHERE filename LIKE "'.mysql_escape_string($row['filename']).'"';
			safe_mysql_query($SQLquery);
			$DupesDeleted++;
		}
		if ($DupesDeleted > 0) {
			echo 'Deleted <B>'.number_format($DupesDeleted).'</B> duplicate filenames<HR>';
		}

		if (!empty($_REQUEST['newscan'])) {
			$AlreadyInDatabase = array();
			set_time_limit(60);
			$SQLquery = 'SELECT filename FROM files ORDER BY filename ASC';
			$result = safe_mysql_query($SQLquery);
			while ($row = mysql_fetch_array($result)) {
				//$AlreadyInDatabase[] = strtolower($row['filename']);
				$AlreadyInDatabase[] = $row['filename'];
			}
		}

		$DirectoriesToScan	= array(realpath(!empty($_REQUEST['scan']) ? $_REQUEST['scan'] : $_REQUEST['newscan']));
		$DirectoriesScanned = array();
		while (count($DirectoriesToScan) > 0) {
			foreach ($DirectoriesToScan as $DirectoryKey => $startingdir) {
				if ($dir = @opendir($startingdir)) {
					set_time_limit(30);
					echo '<B>'.$startingdir.'</B><BR>';
					flush();
					while (($file = readdir($dir)) !== false) {
						if (($file != '.') && ($file != '..')) {
							$RealPathName = realpath($startingdir.'/'.$file);
							if (is_dir($RealPathName)) {
								if (!in_array($RealPathName, $DirectoriesScanned) && !in_array($RealPathName, $DirectoriesToScan)) {
									$DirectoriesToScan[] = $RealPathName;
								}
							} else if (is_file($RealPathName)) {
								if (!empty($_REQUEST['newscan'])) {
									//if (!in_array(strtolower(str_replace('\\', '/', $RealPathName)), $AlreadyInDatabase)) {
									if (!in_array(str_replace('\\', '/', $RealPathName), $AlreadyInDatabase)) {
										$FilesInDir[] = $RealPathName;
									} else {
									}
								} elseif (!empty($_REQUEST['scan'])) {
									$FilesInDir[] = $RealPathName;
								}
							}
						}
					}
					closedir($dir);
				}
				$DirectoriesScanned[] = $startingdir;
				unset($DirectoriesToScan[$DirectoryKey]);
			}
		}
		echo '<I>List of files to scan complete (added '.number_format(count($FilesInDir)).' files to scan)</I><HR>';
		flush();
	}

	$FilesInDir = array_unique($FilesInDir);
	sort($FilesInDir);

	$starttime = time();
	$rowcounter = 0;
	$totaltoprocess = count($FilesInDir);

	$formatExtensions = array('mp3'=>'mp3', 'ogg'=>'ogg', 'zip'=>'zip', 'wav'=>'riff', 'avi'=>'riff', 'mid'=>'midi', 'mpg'=>'mpeg');
	foreach ($FilesInDir as $filename) {
		set_time_limit(30);

		$ThisFileInfo = GetAllFileInfo($filename, '', true, true, true);
		if (empty($ThisFileInfo['fileformat']) || ($ThisFileInfo['fileformat'] == 'id3')) {
			if (isset($formatExtensions[strtolower(fileextension($filename))])) {
				$ThisFileInfo = GetAllFileInfo($filename, $formatExtensions[strtolower(fileextension($filename))], true, true, true);
			}
		}

		$rowcounter++;
		if (empty($ThisFileInfo['fileformat'])) {

			echo '<SPAN STYLE="color: #990099;">'.date('H:i:s').' ['.number_format($rowcounter).' / '.number_format($totaltoprocess).'] '.$filename.'</SPAN><BR>';

		} else {

			if (!empty($_REQUEST['rescanerrors'])) {

				if (!empty($ThisFileInfo['error'])) {
					echo '<SPAN STYLE="color: #FF0000;">';
				} elseif (!empty($ThisFileInfo['warning'])) {
					echo '<SPAN STYLE="color: #FF9999;">';
				} else {
					echo '<SPAN STYLE="color: #009900;">';
				}
				echo date('H:i:s').' ['.number_format($rowcounter).' / '.number_format($totaltoprocess).'] '.$filename.'</SPAN><BR>';

				$SQLquery  = 'UPDATE files SET ';
				$SQLquery .= 'LastModified = "'.mysql_escape_string(@$ThisFileInfo['file_modified_time']).'", ';
				$SQLquery .= 'md5_file = "'.mysql_escape_string(@$ThisFileInfo['md5_file']).'", ';
				$SQLquery .= 'md5_data = "'.mysql_escape_string(@$ThisFileInfo['md5_data']).'", ';
				$SQLquery .= 'md5_data_source = "'.mysql_escape_string(@$ThisFileInfo['md5_data_source']).'", ';
				$SQLquery .= 'filesize = "'.mysql_escape_string(@$ThisFileInfo['filesize']).'", ';
				$SQLquery .= 'fileformat = "'.mysql_escape_string(@$ThisFileInfo['fileformat']).'", ';
				$SQLquery .= 'audio_dataformat = "'.mysql_escape_string(@$ThisFileInfo['audio']['dataformat']).'", ';
				$SQLquery .= 'video_dataformat = "'.mysql_escape_string(@$ThisFileInfo['video']['dataformat']).'", ';
				$SQLquery .= 'audio_bitrate = "'.mysql_escape_string(@$ThisFileInfo['audio']['bitrate']).'", ';
				$SQLquery .= 'video_bitrate = "'.mysql_escape_string(@$ThisFileInfo['video']['bitrate']).'", ';
				$SQLquery .= 'playtime_seconds = "'.mysql_escape_string(@$ThisFileInfo['playtime_seconds']).'", ';
				$SQLquery .= 'tags = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['tags'])).'", ';
				$SQLquery .= 'artist = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['artist'])).'", ';
				$SQLquery .= 'title = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['title'])).'", ';
				$SQLquery .= 'album = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['album'])).'", ';
				$SQLquery .= 'genre = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['genre'])).'", ';
				$SQLquery .= 'comment = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['comment'])).'", ';
				$SQLquery .= 'track = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['track'])).'", ';
				$SQLquery .= 'comments_all = "'.mysql_escape_string(@serialize(@$ThisFileInfo['comments'])).'", ';
				$SQLquery .= 'comments_id3v2 = "'.mysql_escape_string(@serialize(@$ThisFileInfo['id3v2']['comments'])).'", ';
				$SQLquery .= 'comments_ape = "'.mysql_escape_string(@serialize(@$ThisFileInfo['ape']['comments'])).'", ';
				$SQLquery .= 'comments_lyrics3 = "'.mysql_escape_string(@serialize(@$ThisFileInfo['lyrics3']['comments'])).'", ';
				$SQLquery .= 'comments_id3v1 = "'.mysql_escape_string(@serialize(@$ThisFileInfo['id3v1']['comments'])).'", ';
				$SQLquery .= 'warning = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['warning'])).'", ';
				$SQLquery .= 'error = "'.mysql_escape_string(@implode(',', @$ThisFileInfo['error'])).'", ';
				$SQLquery .= 'vbr_method = "'.mysql_escape_string(@$ThisFileInfo['mpeg']['audio']['VBR_method']).'"';
				$SQLquery .= 'WHERE (filename = "'.mysql_escape_string(@$ThisFileInfo['filenamepath']).'")';

			} elseif (!empty($_REQUEST['scan']) || !empty($_REQUEST['newscan'])) {

				echo date('H:i:s').' ['.number_format($rowcounter).' / '.number_format($totaltoprocess).'] '.$filename.'<BR>';

				$SQLquery  = 'INSERT INTO files (filename, LastModified, md5_file, md5_data, md5_data_source, filesize, fileformat, audio_dataformat, video_dataformat, audio_bitrate, video_bitrate, playtime_seconds, tags, artist, title, album, genre, comment, track, comments_all, comments_id3v2, comments_ape, comments_lyrics3, comments_id3v1, warning, error, vbr_method) VALUES (';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['filenamepath']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['file_modified_time']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['md5_file']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['md5_data']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['md5_data_source']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['filesize']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['fileformat']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['audio']['dataformat']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['video']['dataformat']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['audio']['bitrate']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['video']['bitrate']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@$ThisFileInfo['playtime_seconds']).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['tags'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['artist'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['title'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['album'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['genre'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['comment'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['comments']['track'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@serialize(@$ThisFileInfo['comments'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@serialize(@$ThisFileInfo['id3v2']['comments'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@serialize(@$ThisFileInfo['ape']['comments'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@serialize(@$ThisFileInfo['lyrics3']['comments'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@serialize(@$ThisFileInfo['id3v1']['comments'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['warning'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(@implode(',', @$ThisFileInfo['error'])).'", ';
				$SQLquery .= '"'.mysql_escape_string(!empty($ThisFileInfo['mpeg']['audio']['LAME']) ? 'LAME' : @$ThisFileInfo['mpeg']['audio']['VBR_method']).'")';

			}
			flush();
			safe_mysql_query($SQLquery);
		}

	}

	$SQLquery = 'OPTIMIZE TABLE `files`';
	safe_mysql_query($SQLquery);

	echo '<HR>Done scanning!<HR>';

} elseif (!empty($_REQUEST['deadfilescheck'])) {

	$SQLquery  = 'SELECT COUNT(*) AS num, filename';
	$SQLquery .= ' FROM `files`';
	$SQLquery .= ' GROUP BY filename';
	$SQLquery .= ' ORDER BY num DESC';
	$result = safe_mysql_query($SQLquery);
	$DupesDeleted = 0;
	while ($row = mysql_fetch_array($result)) {
		set_time_limit(30);
		if ($row['num'] <= 1) {
			break;
		}
		echo htmlspecialchars($row['filename']).'<BR>';
		$SQLquery = 'DELETE FROM `files` WHERE filename LIKE "'.mysql_escape_string($row['filename']).'"';
		safe_mysql_query($SQLquery);
		$DupesDeleted++;
	}
	if ($DupesDeleted > 0) {
		echo '<HR>Deleted <B>'.number_format($DupesDeleted).'</B> duplicate filenames<HR>';
	}

	$SQLquery  = 'SELECT filename, filesize, LastModified FROM files ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	$totalchecked = 0;
	$totalremoved = 0;
	while ($row = mysql_fetch_array($result)) {
		$totalchecked++;
		set_time_limit(30);
		if (!file_exists($row['filename']) || ($row['LastModified'] != filemtime($row['filename'])) || (filesize($row['filename']) != $row['filesize'])) {
			$totalremoved++;
			echo htmlspecialchars($row['filename']).'<BR>';
			flush();
			$SQLquery = 'DELETE FROM files WHERE (filename = "'.FixDBFields($row['filename']).'")';
			safe_mysql_query($SQLquery);
		}
	}

	echo '<HR><B>'.number_format($totalremoved).' of '.number_format($totalchecked).' files in database no longer exist, or have been altered since last scan. Removed from database.</B><HR>';


} elseif (!empty($_REQUEST['audiobitrates'])) {

	$BitrateDistribution = array();
	$SQLquery  = 'SELECT ROUND(audio_bitrate) AS RoundBitrate, COUNT(*) AS num FROM files GROUP BY ROUND(audio_bitrate)';
	$result = safe_mysql_query($SQLquery);
	while ($row = mysql_fetch_array($result)) {
		safe_inc($BitrateDistribution[ClosestStandardMP3Bitrate($row['RoundBitrate'])], $row['num']);
	}

	echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
	echo '<TR><TH>Bitrate</TH><TH>Count</TH></TR>';
	foreach ($BitrateDistribution as $Bitrate => $Count) {
		echo '<TR>';
		echo '<TD ALIGN="RIGHT">'.$Bitrate.' kbps</TD>';
		echo '<TD ALIGN="RIGHT">'.number_format($Count).'</TD>';
		echo '</TR>';
	}
	echo '</TABLE>';


} elseif (!empty($_REQUEST['emptygenres'])) {

	$SQLquery  = 'SELECT fileformat, filename, genre FROM files WHERE (genre = "") OR (genre = "Unknown") OR (genre = "Other") ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);

	$EmptyGenreCounter = 0;
	echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
	echo '<TR><TH>m3u</TH><TH>filename</TH></TR>';
	while ($row = mysql_fetch_array($result)) {
		if (!in_array($row['fileformat'], $IgnoreNoTagFormats)) {
			$EmptyGenreCounter++;
			echo '<TR>';
			echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($row['filename']).'">m3u</A></TD>';
			echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
			echo '</TR>';
		}
	}
	echo '</TABLE>';
	echo '<B>'.number_format($EmptyGenreCounter).'</B> files with empty genres';

} elseif (!empty($_REQUEST['nonemptycomments'])) {

	die('Not implemented yet');

} elseif (!empty($_REQUEST['trackzero'])) {

	$SQLquery  = 'SELECT filename, track FROM files WHERE (track <> "") AND ((track < "1") OR (track > "99")) ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);

	$TrackZeroCounter = 0;
	echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
	echo '<TR><TH>m3u</TH><TH>filename</TH><TH>track</TH></TR>';
	while ($row = mysql_fetch_array($result)) {
		if ((strlen($row['track']) > 0) && ($row['track'] < 1) || ($row['track'] > 99)) {
			$TrackZeroCounter++;
			echo '<TR>';
			echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($row['filename']).'">m3u</A></TD>';
			echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
			echo '<TD>'.htmlspecialchars($row['track']).'</TD>';
			echo '</TR>';
		}
	}
	echo '</TABLE>';
	echo '<B>'.number_format($TrackZeroCounter).'</B> files with track "zero"';


} elseif (!empty($_REQUEST['synchronizetagsfrom']) && !empty($_REQUEST['filename'])) {

	$Success = SynchronizeAllTags($_REQUEST['filename'], $_REQUEST['synchronizetagsfrom'], 'A12');

	echo 'Applying new tags from <B>'.$_REQUEST['synchronizetagsfrom'].'</B> in <B>'.htmlspecialchars($_REQUEST['filename']).'</B><UL>';
	foreach ($Success as $key => $value) {
		echo '<LI>'.($value ? 'Sucessfully wrote' : 'Write failed for').' '.$key.'</LI>';
	}
	echo '</UL>';


} elseif (!empty($_REQUEST['unsynchronizedtags'])) {

	$NotOKfiles        = 0;
	$FieldsToCompare   = array('title', 'artist', 'album', 'year', 'genre', 'comment', 'track');
	$TagsToCompare     = array('id3v2'=>false, 'ape'=>false, 'lyrics3'=>false, 'id3v1'=>false);
	$ID3v1FieldLengths = array('title'=>30, 'artist'=>30, 'album'=>30, 'year'=>4, 'genre'=>99, 'comment'=>28);
	if (strstr($_REQUEST['unsynchronizedtags'], '2')) {
		$TagsToCompare['id3v2'] = true;
	}
	if (strstr($_REQUEST['unsynchronizedtags'], 'A')) {
		$TagsToCompare['ape'] = true;
	}
	if (strstr($_REQUEST['unsynchronizedtags'], 'L')) {
		$TagsToCompare['lyrics3'] = true;
	}
	if (strstr($_REQUEST['unsynchronizedtags'], '1')) {
		$TagsToCompare['id3v1'] = true;
	}

	echo '<A HREF="'.$_SERVER['PHP_SELF'].'?unsynchronizedtags='.urlencode($_REQUEST['unsynchronizedtags']).'&autofix=1">Auto-fix empty tags</A><BR><BR>';
	echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
	echo '<TR>';
	echo '<TH>Filename</TH>';
	echo '<TH>Combined</TH>';
	if ($TagsToCompare['id3v2']) {
		echo '<TH>ID3v2</TH>';
	}
	if ($TagsToCompare['ape']) {
		echo '<TH>APE</TH>';
	}
	if ($TagsToCompare['lyrics3']) {
		echo '<TH>Lyrics3</TH>';
	}
	if ($TagsToCompare['id3v1']) {
		echo '<TH>ID3v1</TH>';
	}
	echo '</TR>';

	$SQLquery  = 'SELECT filename, comments_all, comments_id3v2, comments_ape, comments_lyrics3, comments_id3v1';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	while ($row = mysql_fetch_array($result)) {

		set_time_limit(30);

		$FileOK      = true;
		$Mismatched  = array('id3v2'=>false, 'ape'=>false, 'lyrics3'=>false, 'id3v1'=>false);
		$SemiMatched = array('id3v2'=>false, 'ape'=>false, 'lyrics3'=>false, 'id3v1'=>false);
		$EmptyTags   = array('id3v2'=>true,  'ape'=>true,  'lyrics3'=>true,  'id3v1'=>true);

		$Comments['all']     = @unserialize($row['comments_all']);
		$Comments['id3v2']   = @unserialize($row['comments_id3v2']);
		$Comments['ape']     = @unserialize($row['comments_ape']);
		$Comments['lyrics3'] = @unserialize($row['comments_lyrics3']);
		$Comments['id3v1']   = @unserialize($row['comments_id3v1']);

		if (isset($Comments['ape']['tracknumber'])) {
			$Comments['ape']['track'] = $Comments['ape']['tracknumber'];
			unset($Comments['ape']['tracknumber']);
		}


		$FileOK = true;

		$ThisLine  = '<TR>';
		//$ThisLine .= '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
		$ThisLine .= '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
		$tagvalues = '';
		foreach ($FieldsToCompare as $fieldname) {
			$tagvalues .= $fieldname.' = '.@$Comments['all']["$fieldname"][0]."\n";
		}
		$ThisLine .= '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?synchronizetagsfrom=all&filename='.urlencode($row['filename']).'" TITLE="'.htmlentities(rtrim($tagvalues, "\n"), ENT_QUOTES).'" TARGET="_retagwindow">all</A></TD>';
		foreach ($TagsToCompare as $tagtype => $CompareThisTagType) {
			if ($CompareThisTagType) {
				$tagvalues = '';
				$tagempty  = true;
				foreach ($FieldsToCompare as $fieldname) {
					if ($tagtype == 'id3v1') {
						require_once(GETID3_INCLUDEPATH.'getid3.id3v1.php');
						if (($fieldname == 'genre') && (LookupGenre(@$Comments['all']["$fieldname"][0], true) === '')) {
							// non-standard genres can never match, so just ignore
							$tagvalues .= $fieldname.' = '.@$Comments["$tagtype"]["$fieldname"][0]."\n";
						} elseif ($fieldname == 'comment') {
							if (rtrim(substr(@$Comments["$tagtype"]["$fieldname"][0], 0, 28)) != rtrim(substr(@$Comments['all']["$fieldname"][0], 0, 28))) {
								$tagvalues .= $fieldname.' = [['.@$Comments["$tagtype"]["$fieldname"][0].']]'."\n";
								if (trim(strtolower(RemoveAccents(substr(@$Comments["$tagtype"]["$fieldname"][0], 0, 28)))) == trim(strtolower(RemoveAccents(substr(@$Comments['all']["$fieldname"][0], 0, 28))))) {
									$SemiMatched["$tagtype"] = true;
								} else {
									$Mismatched["$tagtype"]  = true;
								}
								$FileOK = false;
							} else {
								$tagvalues .= $fieldname.' = '.@$Comments["$tagtype"]["$fieldname"][0]."\n";
							}
						} elseif (rtrim(substr(@$Comments["$tagtype"]["$fieldname"][0], 0, 30)) != rtrim(substr(@$Comments['all']["$fieldname"][0], 0, 30))) {
							$tagvalues .= $fieldname.' = [['.@$Comments["$tagtype"]["$fieldname"][0].']]'."\n";
							if (strtolower(RemoveAccents(trim(substr(@$Comments["$tagtype"]["$fieldname"][0], 0, 30)))) == strtolower(RemoveAccents(trim(substr(@$Comments['all']["$fieldname"][0], 0, 30))))) {
								$SemiMatched["$tagtype"] = true;
							} else {
								$Mismatched["$tagtype"]  = true;
							}
							$FileOK = false;
							if (strlen(trim(@$Comments["$tagtype"]["$fieldname"][0])) > 0) {
								$EmptyTags["$tagtype"] = false;
							}
						} else {
							$tagvalues .= $fieldname.' = '.@$Comments["$tagtype"]["$fieldname"][0]."\n";
							if (strlen(trim(@$Comments["$tagtype"]["$fieldname"][0])) > 0) {
								$EmptyTags["$tagtype"] = false;
							}
						}
					} elseif (($tagtype == 'ape') && ($fieldname == 'year')) {
						if ((@$Comments['ape']['date'][0] != @$Comments['all']['year'][0]) && (@$Comments['ape']['year'][0] != @$Comments['all']['year'][0])) {
							$tagvalues .= $fieldname.' = [['.@$Comments['ape']['date'][0].']]'."\n";
							$Mismatched["$tagtype"]  = true;
							$FileOK = false;
							if (strlen(trim(@$Comments['ape']['date'][0])) > 0) {
								$EmptyTags["$tagtype"] = false;
							}
						} else {
							$tagvalues .= $fieldname.' = '.@$Comments["$tagtype"]["$fieldname"][0]."\n";
							if (strlen(trim(@$Comments["$tagtype"]["$fieldname"][0])) > 0) {
								$EmptyTags["$tagtype"] = false;
							}
						}
					} elseif (@$Comments["$tagtype"]["$fieldname"][0] != @$Comments['all']["$fieldname"][0]) {
						$tagvalues .= $fieldname.' = [['.@$Comments["$tagtype"]["$fieldname"][0].']]'."\n";
							if (trim(strtolower(RemoveAccents(@$Comments["$tagtype"]["$fieldname"][0]))) == trim(strtolower(RemoveAccents(@$Comments['all']["$fieldname"][0])))) {
								$SemiMatched["$tagtype"] = true;
							} else {
								$Mismatched["$tagtype"]  = true;
							}
						$FileOK = false;
						if (strlen(trim(@$Comments["$tagtype"]["$fieldname"][0])) > 0) {
							$EmptyTags["$tagtype"] = false;
						}
					} else {
						$tagvalues .= $fieldname.' = '.@$Comments["$tagtype"]["$fieldname"][0]."\n";
						if (strlen(trim(@$Comments["$tagtype"]["$fieldname"][0])) > 0) {
							$EmptyTags["$tagtype"] = false;
						}
					}
				}
				if ($EmptyTags["$tagtype"]) {
					$ThisLine .= '<TD BGCOLOR="#0099CC">';
				} elseif ($SemiMatched["$tagtype"]) {
					$ThisLine .= '<TD BGCOLOR="#FF9999">';
				} elseif ($Mismatched["$tagtype"]) {
					$ThisLine .= '<TD BGCOLOR="#FF0000">';
				} else {
					$ThisLine .= '<TD BGCOLOR="#00CC00">';
				}
				$ThisLine .= '<A HREF="'.$_SERVER['PHP_SELF'].'?synchronizetagsfrom='.$tagtype.'&filename='.urlencode($row['filename']).'" TITLE="'.htmlentities(rtrim($tagvalues, "\n"), ENT_QUOTES).'" TARGET="_retagwindow">'.$tagtype.'</A>';
				$ThisLine .= '</TD>';
			}
		}
		$ThisLine .= '</TR>';

		if (!$FileOK) {
			$NotOKfiles++;

			if (!empty($_REQUEST['autofix'])) {

				$AnyMismatched = false;
				foreach ($Mismatched as $key => $value) {
					if ($value && ($EmptyTags["$key"] === false)) {
						$AnyMismatched = true;
					}
				}
				if ($AnyMismatched) {

					echo $ThisLine;

				} else {

					$TagsToSynch = '';
					foreach ($EmptyTags as $key => $value) {
						if ($value) {
							switch ($key) {
								case 'id3v1':
									$TagsToSynch .= '1';
									break;
								case 'id3v2':
									$TagsToSynch .= '2';
									break;
								case 'ape':
									$TagsToSynch .= 'A';
									break;
							}
						}
					}
					$Success = SynchronizeAllTags($row['filename'], 'all', $TagsToSynch);
					echo '<TR>';
					echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
					echo '<TD><TABLE BORDER="0">';
					foreach ($Success as $key => $value) {
						echo '<TR><TD BGCOLOR="#'.($value ? '00CC00' : 'FF0000').'"><B>'.$key.'</B></TD></TR>';
					}
					echo '</TABLE></TD></TR>';
				}

			} else {

				echo $ThisLine;

			}
		}
	}

	echo '</TABLE><BR>';
	echo 'Found <B>'.number_format($NotOKfiles).'</B> files with unsynchronzed tags';

} elseif (!empty($_REQUEST['filenamepattern'])) {

	$patterns['A'] = 'artist';
	$patterns['T'] = 'title';
	$patterns['M'] = 'album';
	$patterns['N'] = 'track';
	$patterns['G'] = 'genre';

	$FieldsToUse = explode(' ', wordwrap(eregi_replace('[^A-Z]', '', $_REQUEST['filenamepattern']), 1, ' ', 1));
	foreach ($FieldsToUse as $FieldID) {
		$FieldNames[] = $patterns["$FieldID"];
	}

	$SQLquery  = 'SELECT filename, fileformat, '.implode(', ', $FieldNames);
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (fileformat NOT LIKE "'.implode('") AND (fileformat NOT LIKE "', $IgnoreNoTagFormats).'")';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	echo 'Files that do not match naming pattern:<BR>';
	echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
	echo '<TR><TH>view</TH><TH>Why</TH><TD><B>Actual filename</B><BR>(click to play/edit file)</TD><TD><B>Correct filename (based on tags)</B><BR>(click to rename file to this)</TD></TR>';
	$nonmatchingfilenames = 0;
	$Pattern = $_REQUEST['filenamepattern'];
	$PatternLength = strlen($Pattern);
	while ($row = mysql_fetch_array($result)) {
		set_time_limit(10);
		$PatternFilename = '';
		for ($i = 0; $i < $PatternLength; $i++) {
			if (isset($patterns[$Pattern{$i}])) {
				$PatternFilename .= trim(strtr($row[$patterns[$Pattern{$i}]], ':\\/*<>|', ';-~-[] '), ' ');
			} else {
				$PatternFilename .= $Pattern{$i};
			}
		}
		// get rid of leading & trailing spaces if end items (artist or title for example) are missing
		$PatternFilename  = str_replace(' "', ' ', $PatternFilename);
		$PatternFilename  = str_replace('("', '(', $PatternFilename);
		$PatternFilename  = str_replace('" ', ' ', $PatternFilename.' ');
		$PatternFilename  = str_replace('"', '', $PatternFilename);
		$PatternFilename  = str_replace('?', '', $PatternFilename);
		$PatternFilename  = str_replace('  ', ' ', $PatternFilename);
		$PatternFilename  = trim($PatternFilename, ' -');
		$PatternFilename .= '.'.$row['fileformat'];
		$ActualFilename = basename($row['filename']);
		if ($ActualFilename != $PatternFilename) {
			$NotMatchedReasons = '';
			if (strtolower($ActualFilename) === strtolower($PatternFilename)) {
				$NotMatchedReasons .= 'Aa ';
			} elseif (RemoveAccents($ActualFilename) === RemoveAccents($PatternFilename)) {
				$NotMatchedReasons .= 'e ';
			}
			$ShortestName = min(strlen($ActualFilename), strlen($PatternFilename));
			for ($DifferenceOffset = 0; $DifferenceOffset < $ShortestName; $DifferenceOffset++) {
				if ($ActualFilename{$DifferenceOffset} !== $PatternFilename{$DifferenceOffset}) {
					break;
				}
			}
			echo '<TR>';
			echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">view</A></TD>';
			echo '<TD>&nbsp;'.$NotMatchedReasons.'</TD>';
			echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($row['filename']).'">'.htmlspecialchars($ActualFilename).'</A></TD>';
			echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?filenamepattern='.urlencode($_REQUEST['filenamepattern']).'&renamefilefrom='.urlencode($row['filename']).'&renamefileto='.urlencode(dirname($row['filename']).'/'.$PatternFilename).'" TITLE="'.FixTextFields(basename($row['filename']))."\n".FixTextFields(basename($PatternFilename)).'" TARGET="renamewindow">'.substr($PatternFilename, 0, $DifferenceOffset).'<B>'.substr($PatternFilename, $DifferenceOffset).'</B></A></TD>';
			echo '</TR>';

			$nonmatchingfilenames++;
		}
	}
	echo '</TABLE><BR>';
	echo 'Found '.number_format($nonmatchingfilenames).' files that do not match naming pattern<BR>';

} elseif (!empty($_REQUEST['tagtypes'])) {

	if (!isset($_REQUEST['m3u'])) {
		$SQLquery  = 'SELECT tags, COUNT(*) AS num FROM files';
		$SQLquery .= ' WHERE (fileformat NOT LIKE "'.implode('") AND (fileformat NOT LIKE "', $IgnoreNoTagFormats).'")';
		$SQLquery .= ' GROUP BY tags';
		$SQLquery .= ' ORDER BY num DESC';
		$result = safe_mysql_query($SQLquery);
		echo 'Files with tags:<BR>';
		echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
		echo '<TR><TH>Tags</TH><TH>Count</TH><TH>M3U</TH></TR>';
		while ($row = mysql_fetch_array($result)) {
			echo '<TR>';
			echo '<TD>'.$row['tags'].'</TD>';
			echo '<TD ALIGN="RIGHT"><A HREF="'.$_SERVER['PHP_SELF'].'?tagtypes=1&showtagfiles='.($row['tags'] ? urlencode($row['tags']) : '').'">'.number_format($row['num']).'</A></TD>';
			echo '<TD ALIGN="RIGHT"><A HREF="'.$_SERVER['PHP_SELF'].'?tagtypes=1&showtagfiles='.($row['tags'] ? urlencode($row['tags']) : '').'&m3u=.m3u">m3u</A></TD>';
			echo '</TR>';
		}
		echo '</TABLE><HR>';
	}

	if (isset($_REQUEST['showtagfiles'])) {
		$SQLquery  = 'SELECT filename, tags FROM files';
		$SQLquery .= ' WHERE (tags LIKE "'.mysql_escape_string($_REQUEST['showtagfiles']).'")';
		$SQLquery .= ' AND (fileformat NOT LIKE "'.implode('") AND (fileformat NOT LIKE "', $IgnoreNoTagFormats).'")';
		$SQLquery .= ' ORDER BY filename ASC';
		$result = safe_mysql_query($SQLquery);

		if (!empty($_REQUEST['m3u'])) {

			header('Content-type: audio/x-mpegurl');
			echo '#EXTM3U'."\n";
			while ($row = mysql_fetch_array($result)) {
				echo $row['filename']."\n";
			}
			exit;

		} else {

			echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="3">';
			while ($row = mysql_fetch_array($result)) {
				echo '<TR>';
				echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
				echo '<TD>'.$row['tags'].'</TD>';
				echo '</TR>';
			}
			echo '</TABLE>';

		}
	}


} elseif (!empty($_REQUEST['md5datadupes'])) {

	$OtherFormats = '';
	$AVFormats    = '';

	$SQLquery  = 'SELECT md5_data, filename, COUNT(*) AS num';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' GROUP BY md5_data';
	$SQLquery .= ' ORDER BY num DESC';
	$result = safe_mysql_query($SQLquery);
	while (($row = mysql_fetch_array($result)) && ($row['num'] > 1)) {
		set_time_limit(30);

		$filenames = array();
		$tags      = array();
		$md5_data  = array();
		$SQLquery  = 'SELECT fileformat, filename, tags FROM files';
		$SQLquery .= ' WHERE (md5_data = "'.mysql_escape_string($row['md5_data']).'")';
		$SQLquery .= ' ORDER BY filename ASC';
		$result2 = safe_mysql_query($SQLquery);
		while ($row2 = mysql_fetch_array($result2)) {
			$thisfileformat = $row2['fileformat'];
			$filenames[] = $row2['filename'];
			$tags[]      = $row2['tags'];
			$md5_data[]  = $row['md5_data'];
		}

		$thisline  = '<TR>';
		$thisline .= '<TD VALIGN="TOP" STYLE="font-family: monospace;">'.implode('<BR>', $md5_data).'</TD>';
		$thisline .= '<TD VALIGN="TOP" NOWRAP>'.implode('<BR>', $tags).'</TD>';
		$thisline .= '<TD VALIGN="TOP">'.implode('<BR>', $filenames).'</TD>';
		$thisline .= '</TR>';

		if (in_array($thisfileformat, $IgnoreNoTagFormats)) {
			$OtherFormats .= $thisline;
		} else {
			$AVFormats .= $thisline;
		}
	}
	echo 'Duplicated MD5_DATA (Audio/Video files):<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="2">';
	echo $AVFormats.'</TABLE><HR>';
	echo 'Duplicated MD5_DATA (Other files):<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="2">';
	echo $OtherFormats.'</TABLE><HR>';


} elseif (!empty($_REQUEST['artisttitledupes'])) {

	$SQLquery  = 'SELECT artist, title, filename, COUNT(*) AS num FROM files';
	$SQLquery .= ' WHERE (artist <> "")';
	$SQLquery .= ' AND (title <> "")';
	$SQLquery .= ' GROUP BY artist, title';
	$SQLquery .= ' ORDER BY num DESC, artist ASC, title ASC';
	$result = safe_mysql_query($SQLquery);
	$uniquetitles = 0;
	$uniquefiles  = 0;

	if (!empty($_REQUEST['m3u'])) {

		header('Content-type: audio/x-mpegurl');
		echo '#EXTM3U'."\n";
		while (($row = mysql_fetch_array($result)) && ($row['num'] > 1)) {
			$SQLquery  = 'SELECT filename, artist, title, audio_bitrate, vbr_method, playtime_seconds FROM files';
			$SQLquery .= ' WHERE (artist = "'.mysql_escape_string($row['artist']).'")';
			$SQLquery .= ' AND (title = "'.mysql_escape_string($row['title']).'")';
			$SQLquery .= ' ORDER BY filename ASC';
			$result2 = safe_mysql_query($SQLquery);
			while ($row2 = mysql_fetch_array($result2)) {
				echo $row2['filename']."\n";
			}
		}
		exit;

	} else {

		echo 'Duplicated aritst + title:<BR>';
		echo '(<A HREF="'.$_SERVER['PHP_SELF'].'?artisttitledupes=1&m3u=.m3u">.m3u version</A>)<BR>';
		echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="2">';

		while (($row = mysql_fetch_array($result)) && ($row['num'] > 1)) {
			$uniquetitles++;
			set_time_limit(30);

			$filenames = array();
			$artists   = array();
			$titles    = array();
			$bitrates  = array();
			$playtimes = array();
			$SQLquery  = 'SELECT filename, artist, title, audio_bitrate, vbr_method, playtime_seconds FROM files';
			$SQLquery .= ' WHERE (artist = "'.mysql_escape_string($row['artist']).'")';
			$SQLquery .= ' AND (title = "'.mysql_escape_string($row['title']).'")';
			$SQLquery .= ' ORDER BY filename ASC';
			$result2 = safe_mysql_query($SQLquery);
			while ($row2 = mysql_fetch_array($result2)) {
				$uniquefiles++;
				$filenames[] = $row2['filename'];
				$artists[]   = $row2['artist'];
				$titles[]    = $row2['title'];
				$bitrates[]  = round($row2['audio_bitrate'] / 1000).'k'.($row2['vbr_method'] ? 'v' : '&nbsp;');
				$playtimes[] = PlaytimeString($row2['playtime_seconds']);
			}

			echo '<TR>';
			echo '<TD NOWRAP VALIGN="TOP">';
			foreach ($filenames as $file) {
				echo '<A HREF="getid3.demo.check.php?deletefile='.urlencode($file).'" onClick="return confirm(\'Are you sure you want to delete '.addslashes($file).'? \n(this action cannot be un-done)\');" TITLE="Permanently delete '."\n".FixTextFields($file)."\n".'">delete</A><BR>';
			}
			echo '</TD>';
			echo '<TD NOWRAP VALIGN="TOP">';
			foreach ($filenames as $file) {
				echo '<A HREF="'.$_SERVER['PHP_SELF'].'?m3ufilename='.urlencode($file).'">play</A><BR>';
			}
			echo '</TD>';
			echo '<TD NOWRAP VALIGN="TOP">'.implode('<BR>', $artists).'</TD>';
			echo '<TD NOWRAP VALIGN="TOP">'.implode('<BR>', $titles).'</TD>';
			echo '<TD NOWRAP VALIGN="TOP" ALIGN="RIGHT">'.implode('<BR>', $bitrates).'</TD>';
			echo '<TD NOWRAP VALIGN="TOP" ALIGN="RIGHT">'.implode('<BR>', $playtimes).'</TD>';
			echo '<TD NOWRAP VALIGN="TOP">';
			foreach ($filenames as $file) {
				echo '<A HREF="getid3.demo.check.php?filename='.rawurlencode($file).'">'.$file.'</A><BR>';
			}
			echo '</TD>';
			echo '</TR>';
		}

	}
	echo '</TABLE>';
	echo number_format($uniquefiles).' files with '.number_format($uniquetitles).' unique <I>aritst + title</I><BR>';
	echo '<HR>';

} elseif (!empty($_REQUEST['filetypelist'])) {

	list($fileformat, $audioformat) = explode('|', $_REQUEST['filetypelist']);
	$SQLquery  = 'SELECT filename, fileformat, audio_dataformat';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (fileformat = "'.FixDBFields($fileformat).'")';
	$SQLquery .= ' AND (audio_dataformat = "'.FixDBFields($audioformat).'")';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	echo 'Files of format <B>'.$fileformat.'.'.$audioformat.'</B>:<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
	echo '<TR><TH>file</TH><TH>audio</TH><TH>filename</TH></TR>';
	while ($row = mysql_fetch_array($result)) {
		echo '<TR>';
		echo '<TD>'.$row['fileformat'].'</TD>';
		echo '<TD>'.$row['audio_dataformat'].'</TD>';
		echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
		echo '</TR>';
	}
	echo '</TABLE><HR>';

} elseif (!empty($_REQUEST['trackinalbum'])) {

	$SQLquery  = 'SELECT filename, album';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (album LIKE "% [%")';
	$SQLquery .= ' ORDER BY album ASC, filename ASC';
	$result = safe_mysql_query($SQLquery);
	if (!empty($_REQUEST['m3u'])) {

		header('Content-type: audio/x-mpegurl');
		echo '#EXTM3U'."\n";
		while ($row = mysql_fetch_array($result)) {
			echo $row['filename']."\n";
		}
		exit;

	} elseif (!empty($_REQUEST['autofix'])) {

		require_once(GETID3_INCLUDEPATH.'getid3.id3v1.php');
		require_once(GETID3_INCLUDEPATH.'getid3.id3v2.php');

		while ($row = mysql_fetch_array($result)) {
			set_time_limit(30);
			$ThisFileInfo = GetAllFileInfo($row['filename']);
			if (empty($ThisFileInfo['fileformat']) || ($ThisFileInfo['fileformat'] == 'id3')) {
				if (isset($formatExtensions[strtolower(fileextension($row['filename']))])) {
					$ThisFileInfo = GetAllFileInfo($row['filename'], $formatExtensions[strtolower(fileextension($row['filename']))]);
				}
			}

			if (!empty($ThisFileInfo['tags'])) {

				$Album = trim(str_replace(strstr($ThisFileInfo['comments']['album'][0], ' ['), '', $ThisFileInfo['comments']['album'][0]));
				$Track = (string) intval(str_replace(' [', '', str_replace(']', '', strstr($ThisFileInfo['comments']['album'][0], ' ['))));
				if ($Track == '0') {
					$Track = '';
				}
				if ($Album && $Track) {
					echo '<HR>'.htmlspecialchars($row['filename']).'<BR>';
					echo '<I>'.$Album.'</I> (track #'.$Track.')<BR>';
					echo '<B>ID3v2:</B> '.(RemoveID3v2($row['filename'], false) ? 'removed' : 'REMOVAL FAILED!').', ';
					echo '<B>ID3v1:</B> '.(WriteID3v1($row['filename'], @$ThisFileInfo['comments']['title'][0], @$ThisFileInfo['comments']['artist'][0], $Album, @$ThisFileInfo['comments']['year'][0], @$ThisFileInfo['comments']['comment'][0], @$ThisFileInfo['comments']['genreid'][0], $Track, false) ? 'updated' : 'UPDATE FAILED').'<BR>';
				} else {
					echo ' . ';
				}

			} else {

				echo '<HR>FAILED<BR>'.htmlspecialchars($row['filename']).'<HR>';

			}
			flush();
		}

	} else {

		echo '<B>'.number_format(mysql_num_rows($result)).'</B> files with <B>[??]</B>-format track numbers in album field:<BR>';
		if (mysql_num_rows($result) > 0) {
			echo '(<A HREF="'.$_SERVER['PHP_SELF'].'?trackinalbum=1&m3u=.m3u">.m3u version</A>)<BR>';
			echo '<A HREF="'.$_SERVER['PHP_SELF'].'?trackinalbum=1&autofix=1">Try to auto-fix</A><BR>';
			echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
			while ($row = mysql_fetch_array($result)) {
				echo '<TR>';
				echo '<TD>'.$row['album'].'</TD>';
				echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
				echo '</TR>';
			}
			echo '</TABLE>';
		}
		echo '<HR>';

	}

} elseif (!empty($_REQUEST['fileextensions'])) {

	$SQLquery  = 'SELECT filename, fileformat, audio_dataformat, video_dataformat, tags';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	$invalidextensionfiles = 0;
	$invalidextensionline  = '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
	$invalidextensionline .= '<TR><TH>file</TH><TH>audio</TH><TH>video</TH><TH>tags</TH><TH>actual</TH><TH>correct</TH><TH>filename</TH></TR>';
	while ($row = mysql_fetch_array($result)) {
		set_time_limit(30);

		$acceptableextensions = AcceptableExtensions($row['fileformat'], $row['audio_dataformat'], $row['video_dataformat']);
		$actualextension      = strtolower(fileextension($row['filename']));
		if ($acceptableextensions && !in_array($actualextension, $acceptableextensions)) {
			$invalidextensionfiles++;

			$invalidextensionline .= '<TR>';
			$invalidextensionline .= '<TD>'.$row['fileformat'].'</TD>';
			$invalidextensionline .= '<TD>'.$row['audio_dataformat'].'</TD>';
			$invalidextensionline .= '<TD>'.$row['video_dataformat'].'</TD>';
			$invalidextensionline .= '<TD>'.$row['tags'].'</TD>';
			$invalidextensionline .= '<TD>'.$actualextension.'</TD>';
			$invalidextensionline .= '<TD>'.implode('; ', $acceptableextensions).'</TD>';
			$invalidextensionline .= '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
			$invalidextensionline .= '</TR>';
		}
	}
	$invalidextensionline .= '</TABLE><HR>';
	echo number_format($invalidextensionfiles).' files with incorrect filename extension:<BR>';
	echo $invalidextensionline;

} elseif (isset($_REQUEST['genredistribution'])) {

	if (!empty($_REQUEST['m3u'])) {

		header('Content-type: audio/x-mpegurl');
		echo '#EXTM3U'."\n";
		$SQLquery  = 'SELECT filename';
		$SQLquery .= ' FROM files';
		$SQLquery .= ' WHERE (BINARY genre = "'.$_REQUEST['genredistribution'].'")';
		$SQLquery .= ' AND (fileformat NOT LIKE "'.implode('") AND (fileformat NOT LIKE "', $IgnoreNoTagFormats).'")';
		$SQLquery .= ' ORDER BY filename ASC';
		$result = safe_mysql_query($SQLquery);
		while ($row = mysql_fetch_array($result)) {
			echo $row['filename']."\n";
		}
		exit;

	} else {

		$SQLquery  = 'SELECT COUNT(*) AS num, genre';
		$SQLquery .= ' FROM files';
		$SQLquery .= ' WHERE (fileformat NOT LIKE "'.implode('") AND (fileformat NOT LIKE "', $IgnoreNoTagFormats).'")';
		$SQLquery .= ' GROUP BY genre';
		$SQLquery .= ' ORDER BY num DESC';
		$result = safe_mysql_query($SQLquery);
		require_once(GETID3_INCLUDEPATH.'getid3.id3v1.php');
		echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
		echo '<TR><TH>Count</TH><TH>Genre</TH><TH>m3u</TH></TR>';
		while ($row = mysql_fetch_array($result)) {
			$GenreID = LookupGenre($row['genre'], true);
			if (is_numeric($GenreID)) {
				echo '<TR BGCOLOR="#00FF00;">';
			} else {
				echo '<TR BGCOLOR="#FF9999;">';
			}
			echo '<TD>'.number_format($row['num']).'</TD>';
			echo '<TD>'.$row['genre'].'</TD>';
			echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?m3u=.m3u&genredistribution='.urlencode($row['genre']).'">.m3u</A></TD>';
			echo '</TR>';
		}
		echo '</TABLE><HR>';

	}

} elseif (!empty($_REQUEST['formatdistribution'])) {

	$SQLquery  = 'SELECT fileformat, audio_dataformat, COUNT(*) AS num';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' GROUP BY fileformat, audio_dataformat';
	$SQLquery .= ' ORDER BY num DESC';
	$result = safe_mysql_query($SQLquery);
	echo 'File format distribution:<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
	echo '<TR><TH>Number</TH><TH>Format</TH></TR>';
	while ($row = mysql_fetch_array($result)) {
		echo '<TR>';
		echo '<TD ALIGN="RIGHT">'.number_format($row['num']).'</TD>';
		echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?filetypelist='.$row['fileformat'].'|'.$row['audio_dataformat'].'">'.($row['fileformat'] ? $row['fileformat'] : '<I>unknown</I>').(($row['audio_dataformat'] && ($row['audio_dataformat'] != $row['fileformat'])) ? '.'.$row['audio_dataformat'] : '').'</A></TD>';
		echo '</TR>';
	}
	echo '</TABLE><HR>';

} elseif (!empty($_REQUEST['errorswarnings'])) {

	$SQLquery  = 'SELECT filename, error, warning';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (error <> "")';
	$SQLquery .= ' OR (warning <> "")';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);

	if (!empty($_REQUEST['m3u'])) {

		header('Content-type: audio/x-mpegurl');
		echo '#EXTM3U'."\n";
		while ($row = mysql_fetch_array($result)) {
			echo $row['filename']."\n";
		}
		exit;

	} else {

		echo number_format(mysql_num_rows($result)).' files with errors or warnings:<BR>';
		echo '(<A HREF="'.$_SERVER['PHP_SELF'].'?errorswarnings=1&m3u=.m3u">.m3u version</A>)<BR>';
		echo '<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
		echo '<TR><TH>Filename</TH><TH>Error</TH><TH>Warning</TH></TR>';
		while ($row = mysql_fetch_array($result)) {
			echo '<TR>';
			echo '<TD><A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A></TD>';
			echo '<TD><UL>'.str_replace("\n", '<LI>', FixTextFields($row['error'])).'</UL></TD>';
			echo '<TD><UL>'.str_replace("\n", '<LI>', FixTextFields($row['warning'])).'</UL></TD>';
			echo '</TR>';
		}
	}
	echo '</TABLE><HR>';

} elseif (!empty($_REQUEST['fixid3v1padding'])) {

	require_once(GETID3_INCLUDEPATH.'getid3.id3v1.php');

	$SQLquery  = 'SELECT filename, error, warning';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (error <> "")';
	$SQLquery .= ' OR (warning <> "")';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	$totaltofix = mysql_num_rows($result);
	$rowcounter = 0;
	while ($row = mysql_fetch_array($result)) {
		set_time_limit(30);
		if (strpos($row['warning'], 'Some ID3v1 fields do not use NULL characters for padding') !== false) {
			set_time_limit(30);
			echo (FixID3v1Padding($row['filename'], true) ? '<SPAN STYLE="color: #009900;">fixed - ' : '<SPAN STYLE="color: #FF0000;">error - ');
		} else {
			echo '<SPAN STYLE="color: #0000FF;">No error? - ';
		}
		echo '['.++$rowcounter.' / '.$totaltofix.'] ';
		echo htmlspecialchars($row['filename']).'</SPAN><BR>';
		flush();
	}

} elseif (!empty($_REQUEST['vbrmethod'])) {

	if ($_REQUEST['vbrmethod'] == '1') {

		$SQLquery  = 'SELECT COUNT(*) AS num, vbr_method';
		$SQLquery .= ' FROM files';
		$SQLquery .= ' GROUP BY vbr_method';
		$SQLquery .= ' ORDER BY vbr_method';
		$result = safe_mysql_query($SQLquery);
		echo 'VBR methods:<TABLE BORDER="1" CELLSPACING="0" CELLPADDING="4">';
		echo '<TR><TH>Count</TH><TH>VBR Method</TH></TR>';
		while ($row = mysql_fetch_array($result)) {
			echo '<TR>';
			echo '<TD ALIGN="RIGHT">'.FixTextFields(number_format($row['num'])).'</TD>';
			if ($row['vbr_method']) {
				echo '<TD><A HREF="'.$_SERVER['PHP_SELF'].'?vbrmethod='.$row['vbr_method'].'">'.FixTextFields($row['vbr_method']).'</A></TD>';
			} else {
				echo '<TD><I>CBR</I></TD>';
			}
			echo '</TR>';
		}
		echo '</TABLE>';

	} else {

		$SQLquery  = 'SELECT filename';
		$SQLquery .= ' FROM files';
		$SQLquery .= ' WHERE (vbr_method = "'.FixDBFields($_REQUEST['vbrmethod']).'")';
		$result = safe_mysql_query($SQLquery);
		echo number_format(mysql_num_rows($result)).' files with VBR_method of "'.$_REQUEST['vbrmethod'].'":<BR><BR>>';
		while ($row = mysql_fetch_array($result)) {
			echo '<A HREF="getid3.demo.check.php?filename='.rawurlencode($row['filename']).'">'.htmlspecialchars($row['filename']).'</A><BR>';
		}

	}
	echo '<HR>';

} elseif (!empty($_REQUEST['correctcase'])) {

	$SQLquery  = 'SELECT filename, fileformat';
	$SQLquery .= ' FROM files';
	$SQLquery .= ' WHERE (fileformat <> "")';
	$SQLquery .= ' ORDER BY filename ASC';
	$result = safe_mysql_query($SQLquery);
	echo 'Copy and paste the following into a DOS batch file. You may have to run this script more than once to catch all the changes (remember to scan for deleted/changed files and rescan directory between scans)<HR>';
	echo '<PRE>';
	$lastdir = '';
	while ($row = mysql_fetch_array($result)) {
		set_time_limit(30);
		$CleanedFilename = CleanUpFileName($row['filename']);
		if ($row['filename'] != $CleanedFilename) {
			if (strtolower($lastdir) != strtolower(str_replace('/', '\\', dirname($row['filename'])))) {
				$lastdir = str_replace('/', '\\', dirname($row['filename']));
				echo 'cd "'.$lastdir.'"'."\n";
			}
			echo 'ren "'.basename($row['filename']).'" "'.basename(CleanUpFileName($row['filename'])).'"'."\n";
		}
	}
	echo '</PRE>';
	echo '<HR>';

}

function CleanUpFileName($filename) {
	$DirectoryName = dirname($filename);
	$FileExtension = fileextension(basename($filename));
	$BaseFilename  = basename($filename, '.'.$FileExtension);

	$BaseFilename = strtolower($BaseFilename);
	$BaseFilename = str_replace('_', ' ', $BaseFilename);
	//$BaseFilename = str_replace('-', ' - ', $BaseFilename);
	$BaseFilename = str_replace('(', ' (', $BaseFilename);
	$BaseFilename = str_replace('( ', '(', $BaseFilename);
	$BaseFilename = str_replace(')', ') ', $BaseFilename);
	$BaseFilename = str_replace(' )', ')', $BaseFilename);
	$BaseFilename = str_replace(' \'\'', ' ', $BaseFilename);
	$BaseFilename = str_replace('\'\' ', ' ', $BaseFilename);
	$BaseFilename = str_replace(' vs ', ' vs. ', $BaseFilename);
	while (strstr($BaseFilename, '  ') !== false) {
		$BaseFilename = str_replace('  ', ' ', $BaseFilename);
	}
	$BaseFilename = trim($BaseFilename);

	return $DirectoryName.'/'.BetterUCwords($BaseFilename).'.'.strtolower($FileExtension);
}

function BetterUCwords($string) {
	$stringlength = strlen($string);

	$string{0} = strtoupper($string{0});
	for ($i = 1; $i < $stringlength; $i++) {
		if (($string{$i - 1} == '\'') && ($i > 1) && (($string{$i - 2} == 'O') || ($string{$i - 2} == ' '))) {
			// O'Clock, 'Em
			$string{$i} = strtoupper($string{$i});
		} elseif (ereg('^[\'A-Za-z0-9-]$', $string{$i - 1})) {
			$string{$i} = strtolower($string{$i});
		} else {
			$string{$i} = strtoupper($string{$i});
		}
	}

	static $LowerCaseWords = array('vs.', 'feat.');
	static $UpperCaseWords = array('DJ', 'USA', 'II', 'MC', 'CD', 'TV', '\'N\'');

	$OutputListOfWords = array();
	$ListOfWords = explode(' ', $string);
	foreach ($ListOfWords as $ThisWord) {
		if (in_array(strtolower(str_replace('(', '', $ThisWord)), $LowerCaseWords)) {
			$ThisWord = strtolower($ThisWord);
		} elseif (in_array(strtoupper(str_replace('(', '', $ThisWord)), $UpperCaseWords)) {
			$ThisWord = strtoupper($ThisWord);
		} elseif ((substr($ThisWord, 0, 2) == 'Mc') && (strlen($ThisWord) > 2)) {
			$ThisWord{2} = strtoupper($ThisWord{2});
		} elseif ((substr($ThisWord, 0, 3) == 'Mac') && (strlen($ThisWord) > 3)) {
			$ThisWord{3} = strtoupper($ThisWord{3});
		}
		$OutputListOfWords[] = $ThisWord;
	}
	$UCstring = implode(' ', $OutputListOfWords);
	$UCstring = str_replace(' From ', ' from ', $UCstring);
	$UCstring = str_replace(' \'n\' ', ' \'N\' ', $UCstring);

	return $UCstring;
}

echo '<HR><FORM ACTION="'.FixTextFields($_SERVER['PHP_SELF']).'">';
echo '<B>Warning:</B> Scanning a new directory will erase all previous entries in the database!<BR>';
echo 'Directory: <INPUT TYPE="TEXT" NAME="scan" VALUE="'.FixTextFields(!empty($_REQUEST['scan']) ? $_REQUEST['scan'] : '').'"> ';
echo '<INPUT TYPE="SUBMIT" VALUE="Go">';
echo '</FORM>';
echo '<HR><FORM ACTION="'.FixTextFields($_SERVER['PHP_SELF']).'">';
echo 'Re-scanning a new directory will only add new, previously unscanned files into the list (and not erase the database).<BR>';
echo 'Directory: <INPUT TYPE="TEXT" NAME="newscan" VALUE="'.FixTextFields(!empty($_REQUEST['newscan']) ? $_REQUEST['newscan'] : '').'"> ';
echo '<INPUT TYPE="SUBMIT" VALUE="Go">';
echo '</FORM><HR>';
echo '<UL>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?deadfilescheck=1">Remove deleted or changed files from database</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?md5datadupes=1">List files with identical MD5_DATA values</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?artisttitledupes=1">List files with identical artist + title</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?fileextensions=1">File with incorrect file extension</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?formatdistribution=1">File Format Distribution</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?audiobitrates=1">Audio Bitrate Distribution</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?vbrmethod=1">VBR_Method Distribution</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?tagtypes=1">Tag Type Distribution</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?genredistribution=%">Genre Distribution</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?trackinalbum=1">Track number in Album field</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?emptygenres=1">Blank genres</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?trackzero=1">Track "zero"</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?nonemptycomments=1">non-empty comments</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?unsynchronizedtags=2A1">Tags that are not synchronized</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?filenamepattern='.urlencode('A - T').'">Filenames that don\'t match pattern</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?correctcase=1">Correct filename case (Win/DOS)</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?fixid3v1padding=1">Fix ID3v1 invalid padding</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?errorswarnings=1">Files with Errors and/or Warnings</A></LI>';
echo '<LI><A HREF="'.$_SERVER['PHP_SELF'].'?rescanerrors=1">Re-scan only files with Errors and/or Warnings</A></LI>';
echo '</UL>';

?>
</BODY>
</HTML>